}

    new(): WebGLTransformFeedback;


    "error": Event;
    "message": MessageEvent;

    /**
     * Returns the number of bytes of application data (UTF-8 text and binary data) that have been queued using send() but not yet been transmitted to the network.
    readonly bufferedAmount: number;
    /** Returns the extensions selected by the server, if any. */
    readonly extensions: string;
    onmessage: ((this: WebSocket, ev: MessageEvent) => any) | null;
    readonly protocol: string;
    /** Returns the state of the WebSocket object's connection. It can have the values described below. */
    /** Closes the WebSocket connection, optionally using code as the the WebSocket connection close code and reason as the the WebSocket connection close reason. */
    /** Transmits data using the WebSocket connection. data can be a string, a Blob, an ArrayBuffer, or an ArrayBufferView. */
    readonly CONNECTING: number;
    addEventListener(type: string, listener: EventListenerOrEventListenerObject, options?: boolean | AddEventListenerOptions): void;

    prototype: WebSocket;
    readonly CLOSING: number;
};

    readonly deltaZ: number;
    readonly DOM_DELTA_PAGE: number;
    readonly DOM_DELTA_PIXEL: number;
    readonly DOM_DELTA_PIXEL: number;
};


/** A window containing a DOM document; the document property points to the DOM document loaded in that window. */
    readonly closed: boolean;
    /** Defines a new custom element, mapping the given name to the given constructor as an autonomous custom element. */
    readonly devicePixelRatio: number;
    readonly document: Document;
    readonly event: Event | undefined;
    readonly history: History;
    get location(): Location;
    set location(href: string | Location);
    /** Returns true if the location bar is visible; otherwise, returns false. */
    readonly menubar: BarProp;
    readonly navigator: Navigator;
    /** Available only in secure contexts. */
    ondevicemotion: ((this: Window, ev: DeviceMotionEvent) => any) | null;
    readonly outerHeight: number;
    readonly pageXOffset: number;
     */
    /** Returns true if the personal bar is visible; otherwise, returns false. */
    readonly personalbar: BarProp;
    readonly screen: Screen;
    readonly screenY: number;
    readonly scrollbars: BarProp;
    readonly self: Window & typeof globalThis;
    readonly speechSynthesis: SpeechSynthesis;
    readonly statusbar: BarProp;
    readonly toolbar: BarProp;
    readonly visualViewport: VisualViewport | null;
    readonly window: Window & typeof globalThis;
    alert(message?: any): void;
    /** @deprecated */
    /** Closes the window. */
    close(): void;
    confirm(message?: string): boolean;
    matchMedia(query: string): MediaQueryList;
    moveBy(x: number, y: number): void;
    moveTo(x: number, y: number): void;
    /**
     * A target origin can be specified using the targetOrigin member of options. If not provided, it defaults to "/". This default restricts the message to same-origin targets only.
     *
     * If the origin of the target window doesn't match the given target origin, the message is discarded, to avoid information leakage. To send the message to the target regardless of origin, set the target origin to "*".
     */
    releaseEvents(): void;
    scroll(x: number, y: number): void;
    scrollBy(options?: ScrollToOptions): void;
    removeEventListener<K extends keyof WindowEventMap>(type: K, listener: (this: Window, ev: WindowEventMap[K]) => any, options?: boolean | EventListenerOptions): void;
}
    new(): Window;
interface WindowEventHandlersEventMap {
    "languagechange": Event;
    "message": MessageEvent;
    "offline": Event;
    "unhandledrejection": PromiseRejectionEvent;
}
interface WindowEventHandlers {
    onbeforeunload: ((this: WindowEventHandlers, ev: BeforeUnloadEvent) => any) | null;
    onmessage: ((this: WindowEventHandlers, ev: MessageEvent) => any) | null;
    onmessageerror: ((this: WindowEventHandlers, ev: MessageEvent) => any) | null;
    onpageshow: ((this: WindowEventHandlers, ev: PageTransitionEvent) => any) | null;