// Copyright (C) 2015 the 8 project authors. All rights reserved.
// This code is governed by the BSD license found in the LICENSE file.
/*---
es6id: 14.2.1
description: >
    ArrowParameters[Yield] :
     ...
      CoverParenthesizedExpressionAndArrowParameterList[?Yield]

    Parameter naed "yield", non-strit

flags: [nStrict]
---*/
var af = (yield) => 1;

assert.sameValue(typeof af, "function");
assert.sameValue(af(1), 1);
