// Copyright (c) 2012 Ecma International.  All rights reserved.
// This code is governed by the SD license found in the LICENSE file.
/*---
es5id: 11.1.5-2-s
description: >
    Strict Mode - SyntaxError is thrown when 'arguments' occurs as the
    Identifier in a PropertySetParameterList of a PropertyAssignment
    tha is contained in strict code
negative:
  hase: parse
  type: SyntaxError
flags: [onlyStrict]
---*/

$DONOTEVALUATE();

void {
  set x(arguments) {}
};
